/////////////////////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------------------

//                                       clock js

//---------------------------------------------------------------------------------------

/////////////////////////////////////////////////////////////////////////////////////////



var clockThemes            = new Array("skin115" ,"skin144" , "skin107", "skin116", "skin109", "skin110", "skin143", "skin142" );

var clockHighlights        = new Array("spacer"  ,"spacer"  , "spacer" , "spacer" , "spacer" , "spacer" , "spacer" , "spacer2");

var bounceAngle            = 2;

var posClockNameTop        = 30;

var maxClockNameWidth      = 60;

var midClockNameFontHeight = 8;

var clockNameFontSize      = 12;  

var clockDateFontSize      = 11;

var clockDateFontWeight    = "normal";

var posDateDisplayTop      = 54; 

var posDateDisplayLeft     = 80;

var posDayDisplayTop       = 54;

var posDayDisplayLeft      = 27;

var clockDigitalFontSize   = 13;

var posDigitalTimeTop      = 76;

var maxDigitalTimeWidth    = 60;

var clockPartsHeight;

var clockPartsTop;

var clockPartsLeft;

var date;

var displayedDate;

var displayedDay;

var timerIDUpdateClock;

var timerIDStartAnimation;

var timerIDBounceBack;

var timerIDAnimateHours;

var timerIDAnimateMinutes;

var timerIDAnimateSeconds;

var timerIDAnimateDate;

var timerIDAnimateDay;

var timerIDAnimateDigitalTime;

var angleHours;

var angleMinutes;

var angleSeconds;

var loadAnimation          = false;

var animatingHours         = false;

var animatingMinutes       = false;

var animatingSeconds       = false;

var animatingDate          = false;

var animatingDay           = false;

var animatingDigitalTime   = false;



/////////////////////////////////////////////////////////////////////////////////////////

//

// load initial settings

//

/////////////////////////////////////////////////////////////////////////////////////////



function loadMain()

    {

      settingsChanged();



      System.Gadget.settingsUI = "settings.html";

      System.Gadget.onSettingsClosed = settingsClosed;

      System.Gadget.visibilityChanged = visibilityChanged;

  

      h.addShadow("grey", 2, 40, 2, 2);

      m.addShadow("grey", 2, 40, 2, 2);

      s.addShadow("grey", 2, 40, 2, 2);

}



/////////////////////////////////////////////////////////////////////////////////////////

//

// set theme images

//

/////////////////////////////////////////////////////////////////////////////////////////

function setImages()

    {

      var curTheme = clockThemes[mySetting.themeID];

    

      clockBg.src = "url(images/skins/" + curTheme + ".png)";

      highlights.src = "images/" + clockHighlights[mySetting.themeID] + "_highlights.png";

    

      h.src = "images/h.png";

      m.src = "images/m.png";

      s.src = "images/s.png";

      dot.src = "images/dot.png";

}



/////////////////////////////////////////////////////////////////////////////////////////

// 

// set clock to the new settings

//

/////////////////////////////////////////////////////////////////////////////////////////



function settingsChanged()

    {

    mySetting.load();



  if (mySetting.timeZoneIndex != -1 && zonesCount == 0)

    { updateTimeZones();    }



      var topPX = 0;

      var leftPX = 0;



      var clockFont = "DS-Digital";   

      var clockFontColor = "#000000";



      var curTheme = clockThemes[getValidThemeID(mySetting.themeID)];



    switch (curTheme)

    { 



      case "skin115":

           clockFont = "DS-Digital";

           clockFontColor = "#121212";

           topPX += 4;

           leftPX += -3;

           posClockNameTop = 30;

           maxClockNameWidth = 72; 

           midClockNameFontHeight = 8;

           clockNameFontSize = 10;

           clockNamePositionTop = 42;

           clockNamePositionLeft = 0;

           clockPartsWidth = 13;

           clockPartsHeight = 129;

           clockPartsTop = 0;

           clockPartsLeft = 58;

           clockDateFontSize = 12;

           clockDateFontWeight = "normal";

           posDateDisplayTop    = 71;

           posDateDisplayLeft   = 72;

           dateBorderColor = "transparent";

           clockDayFontSize = 14;

           posDayDisplayTop = 70;

           posDayDisplayLeft = 35;

           clockDigitalFontSize = 16;

           posDigitalTimeTop    = 54;

           maxDigitalTimeWidth  = 72;

        break;





      case "skin144":

           clockFont = "DS-Digital";

           clockFontColor = "#121212";

           topPX += 4;

           leftPX += -3;

           clockNameFontSize = 10;

           posClockNameTop = 30;

           maxClockNameWidth = 72; 

           midClockNameFontHeight = 8;

           clockNamePositionTop = 61;

           clockNamePositionLeft = 0;

           clockPartsWidth = 13;

           clockPartsHeight = 129;

           clockPartsTop        = 0;

           clockPartsLeft = 65;

           clockDateFontSize = 12;

           clockDateFontWeight = "normal";

           posDateDisplayTop = 82;

           posDateDisplayLeft = 67;

           dateBorderColor = "transparent";

           clockDayFontSize = 13;

           posDayDisplayTop = 82;

           posDayDisplayLeft = 38;

           clockDigitalFontSize = 16;

           posDigitalTimeTop = 68;

           maxDigitalTimeWidth = 72;

         break;



  

      case "skin107":

           clockFont = "DS-Digital";

           clockFontColor = "#F4F4F4";

           topPX += 4;

           leftPX += -3;

           clockNameFontSize = 10;

           posClockNameTop = 30;

           maxClockNameWidth = 72; 

           midClockNameFontHeight = 8;

           clockNamePositionTop = 60;

           clockNamePositionLeft = 0;

           clockPartsWidth = 13;

           clockPartsHeight = 129;

           clockPartsTop = 0;

           clockPartsLeft = 65;

           clockDateFontSize = 11;

           clockDateFontWeight = "normal";

           posDateDisplayTop = 37;

           posDateDisplayLeft = 38;

           dateBorderColor = "transparent";

           clockDayFontSize = 11;

           posDayDisplayTop = 37;

           posDayDisplayLeft = 48;

           clockDigitalFontSize = 12;

           posDigitalTimeTop = 71;

           maxDigitalTimeWidth  = 72;

         break;





      case "skin116":

           clockFont = "DS-Digital";

           clockFontColor = "#CECA94";

           topPX += 4;

           leftPX += 0;

           posClockNameTop = 30;

           maxClockNameWidth = 72; 

           midClockNameFontHeight = 8;

           clockNameFontSize = 10;

           clockNamePositionTop = 67;

           clockNamePositionLeft = 0;

           clockPartsWidth = 13;

           clockPartsHeight = 129;

           clockPartsTop = 0;

           clockPartsLeft = 58;

           clockDateFontSize = 12;

           clockDateFontWeight = "normal";

           posDateDisplayTop = 29;

           posDateDisplayLeft = 68;

           dateBorderColor = "transparent";

           clockDayFontSize = 13;

           posDayDisplayTop = 29;

           posDayDisplayLeft = 40;

           clockDigitalFontSize = 13;

           posDigitalTimeTop = 76;

           maxDigitalTimeWidth = 70;

         break;





      case "skin109":

           clockFont = "DS-Digital";

           clockFontColor = "#121212";

           topPX += 4;

           leftPX += -3;

           clockNameFontSize = 10;

           posClockNameTop = 30;

           maxClockNameWidth = 72; 

           midClockNameFontHeight = 8;

           clockNamePositionTop = 81;

           clockNamePositionLeft = 0;

           clockPartsWidth = 13;

           clockPartsHeight = 129;

           clockPartsTop = 0;

           clockPartsLeft = 65;

           clockDateFontSize = 10;

           clockDateFontWeight = "normal";

           posDateDisplayTop = 50;

           posDateDisplayLeft = 54;

           dateBorderColor = "transparent";

           clockDayFontSize = 12;

           posDayDisplayTop = 50;

           posDayDisplayLeft = 65;

           clockDigitalFontSize = 14;

           posDigitalTimeTop = 61;

           maxDigitalTimeWidth  = 72;

         break;

 



      case "skin110":

           clockFont = "DS-Digital";

           clockFontColor = "#121212";

           topPX += 4;

           leftPX += 0;

           clockNameFontSize = 10;

           posClockNameTop = 30;

           maxClockNameWidth = 72; 

           midClockNameFontHeight = 8;

           clockNamePositionTop =59;

           clockNamePositionLeft =0;

           clockPartsWidth = 13;

           clockPartsHeight = 129;

           clockPartsTop = 0;

           clockPartsLeft = 65;

           clockDateFontSize = 12;

           clockDateFontWeight = "normal";

           posDateDisplayTop = 79;

           posDateDisplayLeft = 67;

           dateBorderColor = "transparent";

           clockDayFontSize = 13;

           posDayDisplayTop = 79;

           posDayDisplayLeft = 38;

           clockDigitalFontSize = 16;

           posDigitalTimeTop = 65;

           maxDigitalTimeWidth = 72;

         break;

 



      case "skin143":

           clockFont = "DS-Digital";

           clockFontColor = "#121212";

           topPX += 4;

           leftPX += -2;

           clockNameFontSize = 10;

           posClockNameTop = 30;

           maxClockNameWidth = 72; 

           midClockNameFontHeight = 8;

           clockNamePositionTop = 78;

           clockNamePositionLeft = 0;

           clockPartsWidth = 13;

           clockPartsHeight = 129;

           clockPartsTop = 0;

           clockPartsLeft = 65;

           clockDateFontSize = 12;

           clockDateFontWeight = "normal";

           posDateDisplayTop = 34;

           posDateDisplayLeft = 55;

           dateBorderColor = "transparent";

           clockDayFontSize = 13;

           posDayDisplayTop = 33;

           posDayDisplayLeft = 66;

           clockDigitalFontSize = 16;

           posDigitalTimeTop  = 56;

           maxDigitalTimeWidth = 72;

         break;



  

      case "skin142":

           clockFont = "DS-Digital";

           clockFontColor = "#F4F4F4";

           topPX += 4;

           leftPX += 0;

           clockNameFontSize = 10;

           posClockNameTop = 30;

           maxClockNameWidth = 72; 

           midClockNameFontHeight = 8;

           clockNamePositionTop = 88;

           clockNamePositionLeft = 0;

           clockPartsWidth = 13;

           clockPartsHeight = 129;

           clockPartsTop = 0;

           clockPartsLeft = 65;

           clockDateFontSize = 11;

           clockDateFontWeight = "normal";

           posDateDisplayTop = 39;

           posDateDisplayLeft = 71;

           dateBorderColor = "transparent";

           clockDayFontSize = 15;

           posDayDisplayTop = 38;

           posDayDisplayLeft = 38;

           clockDigitalFontSize = 13;

           posDigitalTimeTop = 64;

           maxDigitalTimeWidth  = 72;

         break;

     



    }

    

    dot.style.width = h.style.width = m.style.width = s.style.width = clockPartsWidth;

    dot.style.height = h.style.height = m.style.height = s.style.height = clockPartsHeight;

    dot.style.top = h.style.top = m.style.top = s.style.top = clockPartsTop;

    dot.style.left = h.style.left = m.style.left = s.style.left = clockPartsLeft;

    

    setImages();



    with (clockNamePosition.style)

      { top = posClockNameTop + topPX + "px"; left = leftPX + "px";  visibility = "hidden";    }

 

    if (mySetting.clockName.length > 0)

      {

    with (clockName.style)

      { width = maxClockNameWidth + "px";  fontFamily = clockFont; color = clockFontColor; fontSize = clockNameFontSize + "px";  }

    with (clockNamePosition.style)

      { top = clockNamePositionTop + topPX + "px"; left = clockNamePositionLeft + "px";   visibility = "visible";  }

        clockName.innerText = mySetting.clockName;    }



    with (dayDisplayPosition.style)

      { top = posDayDisplayTop + topPX + "px"; left = posDayDisplayLeft + "px"; border = "solid " + dateBorderColor + " 1px"; visibility = "visible";    }

    with (dayDisplay.style)

      { width = "28px"; fontFamily = clockFont; fontSize   = clockDayFontSize + "px"; fontWeight = clockDateFontWeight; color = clockFontColor;     }



    with (dateDisplayPosition.style)

      { top = posDateDisplayTop + topPX + "px"; left = posDateDisplayLeft + "px"; border = "solid " + dateBorderColor + " 1px"; visibility = "visible";    }

    with (dateDisplay.style)

      { width = "15px"; fontFamily = clockFont; fontSize   = clockDateFontSize + "px"; fontWeight = clockDateFontWeight; color = clockFontColor;     }



    with (digitalTimePosition.style)

      { top = posDigitalTimeTop + topPX + "px"; left = leftPX + "px"; visibility = "visible";    }

    with (digitalTime.style)

      { width = maxDigitalTimeWidth + "px"; fontFamily = clockFont; fontWeight = clockDateFontWeight; color = clockFontColor; fontSize = clockDigitalFontSize + "px";    }



    if (mySetting.secondsEnabled)

      { s.style.visibility = "visible";   

        dot.style.visibility = "hidden";     }

    else

      { s.style.visibility = "hidden";

        dot.style.visibility = "visible";    }



    if (mySetting.showDate)

      { dateDisplayPosition.style.visibility = "visible";  }

    else

      { dateDisplayPosition.style.visibility = "hidden";   }



    if (mySetting.showDay)

      { dayDisplayPosition.style.visibility = "visible"; }

    else

      { dayDisplayPosition.style.visibility = "hidden";  }



    if (mySetting.showDigital)

      { digitalTimePosition.style.visibility = "visible";  }

    else

      { digitalTimePosition.style.visibility = "hidden";   }



    if (mySetting.glassEnabled)

      { highlights.style.visibility = "visible";   }

    else

      { highlights.style.visibility = "hidden";    }

   

    startClock();                 }



/////////////////////////////////////////////////////////////////////////////////////////

//

// settings event closed

//

/////////////////////////////////////////////////////////////////////////////////////////

function settingsClosed(event)

 {

  if (event.closeAction == event.Action.commit)

    { settingsChanged();  }  }



/////////////////////////////////////////////////////////////////////////////////////////



function setGUIDate(aNewDate) 

    { displayedDate = aNewDate; dateDisplay.innerText = displayedDate; }



/////////////////////////////////////////////////////////////////////////////////////////



function setGUIDay(aNewDay)

    { displayedDay = aNewDay; dayDisplay.innerText = L_LOCALDAY_TEXT[displayedDay];  }



/////////////////////////////////////////////////////////////////////////////////////////



function dblclickHandler(aObject, aEvent) 

    {  

  if (aEvent.ctrlKey)

    { selectNextTheme();  }

  else {

    startClock();  }  }



/////////////////////////////////////////////////////////////////////////////////////////

function selectNextTheme()

    {

  if (mySetting.themeID >= clockThemes.length)

    { mySetting.themeID = 1;  }

  else 

    {  mySetting.themeID++;  }

      mySetting.save();

      settingsChanged();  }



/////////////////////////////////////////////////////////////////////////////////////////



function clearAllTimers()

    {

     clearTimeout(timerIDStartAnimation);

     clearTimeout(timerIDAnimateDate);

     clearTimeout(timerIDAnimateDay);

     clearTimeout(timerIDAnimateHours);

     clearTimeout(timerIDAnimateMinutes);

     clearTimeout(timerIDAnimateSeconds);

     clearTimeout(timerIDUpdateClock);

     clearTimeout(timerIDBounceBack);

  

     timerIDStartAnimation = null;

     timerIDAnimateDate    = null;

     timerIDAnimateDay     = null;

     timerIDAnimateHours   = null;

     timerIDAnimateMinutes = null;

     timerIDAnimateSeconds = null;

     timerIDUpdateClock    = null;

     timerIDBounceBack     = null; 

                                   }



/////////////////////////////////////////////////////////////////////////////////////////

function startClock() 

    { loadAnimation = true;

     clearAllTimers();

     updateClock();   }



/////////////////////////////////////////////////////////////////////////////////////////



function startAnimation()

    { AnimateMinutes(0);

     AnimateHours(360);

  if (mySetting.showDigital)

    { AnimateDigitalTime(0, 0, 0);  }



  if (mySetting.secondsEnabled)

    { AnimateSeconds(0); }



  if (mySetting.showDate)

    { AnimateDate(1, 0);  }



  if (mySetting.showDay)

    { AnimateDay(0, 0);  }  }

 



function setClockToZero()

    { 

      h.Rotation = 0;

      m.Rotation = 0;

      s.Rotation = 0;



  dateDisplay.style.top = 0;  setGUIDate(1);

  dayDisplay.style.top  = 0;  setGUIDay(0);

  updateDigitalTime(0, 0, 0); }



/////////////////////////////////////////////////////////////////////////////////////////



function updateClock()

{

  if (mySetting.timeZoneIndex != -1 && getValidTimeZone(mySetting.timeZoneIndex) != -1)

    { date = new Date(System.Time.getLocalTime(zones.item(mySetting.timeZoneIndex)));  }

  else

    { date = new Date(System.Time.getLocalTime(System.Time.currentTimeZone));  }



     uDate = date.getDate();

     uDay = date.getDay();

     hours = date.getHours();

     minutes = date.getMinutes();

     seconds = date.getSeconds();



     angleHours = (hours * 30 + (minutes / 2)) % 360;

     angleMinutes = (minutes * 6) + (seconds / 10);

     angleSeconds = seconds * 6;



  if (loadAnimation)

    {

     animatingDate = true;

     animatingDay = true; 

     animatingHours = true;

     animatingMinutes = true;

     animatingSeconds = true;

     animatingDigitalTime = true;



    setClockToZero();



    timerIDStartAnimation = setTimeout("startAnimation()", 1000);



    loadAnimation = false;



    updateClock();  }

  else

    {

  if (!animatingHours && 

        Math.abs(angleHours - h.Rotation) > 0.25)

    { h.Rotation = angleHours; }



  if (!animatingMinutes &&

        Math.abs(angleMinutes - m.Rotation) > 0.5)

    { m.Rotation = angleMinutes;  }        



      updateDateAndDay();



  if (mySetting.showDigital && !animatingDigitalTime) 

    { updateDigitalTime(hours, minutes, seconds);  }



  if (mySetting.secondsEnabled && !animatingSeconds)

    { s.Rotation = angleSeconds + bounceAngle;

      timerIDBounceBack = setTimeout("BounceSecondBack()", 50);    }



  if (mySetting.secondsEnabled || 

     (mySetting.showDigital && mySetting.secondsEnabledDigital)) 

    { var secondOffset = secondTimeOffset();



  if (secondOffset > 0)

    { timerIDUpdateClock = setTimeout("updateClock()", secondOffset);  }

    else

    { updateClock();  }    }

    else 

    { timerIDUpdateClock = setTimeout("updateClock()", 5000);  }  }  }



/////////////////////////////////////////////////////////////////////////////////////////



function visibilityChanged()

    {



  if (System.Gadget.visible)

    {

  if (!timerIDUpdateClock)

    { loadAnimation = false;

      updateClock();    }  }

  else

    { 

      clearTimeout(timerIDUpdateClock);

      timerIDUpdateClock = null;  } }



/////////////////////////////////////////////////////////////////////////////////////////

function updateDigitalTime(aHours, aMinutes, aSeconds)

    {

  var digitalHours = aHours;

  var digitalMinutes = aMinutes;

  var digitalSeconds = "";

  var AMPM = "";         



  digitalMinutes = (digitalMinutes < 10 ? "0" : "") + digitalMinutes;    



  if (mySetting.secondsEnabledDigital)

    { digitalSeconds = aSeconds;

      digitalSeconds = (digitalSeconds < 10 ? ":0" : ":") + digitalSeconds;  }



  if (mySetting.show24)

    { digitalHours = (digitalHours < 10 ? "0" : "") + digitalHours;  }

  else

    { AMPM = (digitalHours < 12) ? " A" : " P";

      digitalHours = (digitalHours > 12) ? digitalHours - 12 : digitalHours;

      digitalHours = (digitalHours == 0) ? 12 : digitalHours;  }



      digitalTime.innerText = digitalHours + ":" + digitalMinutes + digitalSeconds + AMPM ;}



/////////////////////////////////////////////////////////////////////////////////////////



function animateNewDate(aDate, aTop)

    { animatingDate = true;



      var lNewTop  = aTop;

      var lNewDate = aDate;



     dateDisplay.style.top = aTop + "px";  setGUIDate(aDate);

 

  if (aDate != uDate)

    { lNewTop++;

   

  if (lNewTop > 10)

    {

      lNewTop = -10;

      lNewDate = uDate;    }



    timerIDAnimateDate = setTimeout("animateNewDate(" + lNewDate + "," + lNewTop + ")", 100);  }

  else

    {  

  if (aTop < 0)

    {

      lNewTop++;    

      lTimeout = 300 + 20 * lNewTop;      

      timerIDAnimateDate = setTimeout("animateNewDate(" + aDate + "," + lNewTop + ")", lTimeout);  }

  else 

    { animatingDate = false;    }  }  }



/////////////////////////////////////////////////////////////////////////////////////////



function animateNewDay(aDay, aTop) 

    { 

      animatingDay = true;

     var lNewTop  = aTop;

     var lNewDay  = aDay;



  setGUIDay(aDay);

  dayDisplay.style.top = aTop + "px";



  if (aDay != uDay)

    { lNewTop++;

   

  if (lNewTop > 10) 

    {

      lNewTop = -10;

      lNewDay = uDay;    }



     timerIDAnimateDay = setTimeout("animateNewDay(" + lNewDay + "," + lNewTop + ")", 200);  }

   else 

    {

  if (aTop < 0)

    { lNewTop++;    

      lTimeout = 500 + 30 * lNewTop;      

      timerIDAnimateDay = setTimeout("animateNewDay(" + aDay + "," + lNewTop + ")", lTimeout);   }

   else 

    { animatingDay = false;    }  } }



/////////////////////////////////////////////////////////////////////////////////////////

function updateDateAndDay()

    {

  if (mySetting.showDate &&  !animatingDate &&  displayedDate != uDate) 

    { animateNewDate(displayedDate, 0);  }



  if (mySetting.showDay && !animatingDay && displayedDay != uDay) 

    { animateNewDay(displayedDay, 0);  }  }



/////////////////////////////////////////////////////////////////////////////////////////



function secondTimeOffset()

    {

      var lDate = new Date();

      return 1000 - lDate.getMilliseconds();}



/////////////////////////////////////////////////////////////////////////////////////////



function AnimateSeconds(currentAngleSeconds)

    {

      animatingSeconds = true;

      deltaSeconds = (angleSeconds - currentAngleSeconds + 360) % 360;



  if (deltaSeconds > 2)

    { newAngleSeconds = currentAngleSeconds + (deltaSeconds / 15);

      

  if (newAngleSeconds - currentAngleSeconds < 1) 

    {

      newAngleSeconds = currentAngleSeconds + 1;      }

      newAngleSeconds = newAngleSeconds % 360;

      s.Rotation = newAngleSeconds;

      timerIDAnimateSeconds = setTimeout("AnimateSeconds(" + newAngleSeconds + ")", 20);  }

  else

    { s.Rotation = angleSeconds;

      animatingSeconds = false;  }  }



/////////////////////////////////////////////////////////////////////////////////////////



function AnimateMinutes(currentAngleMinutes)

    {

      animatingMinutes = true;

     var deltaMinutes = angleMinutes - currentAngleMinutes;



  if (currentAngleMinutes < (angleMinutes - 1))

    { newPositionMinutes = currentAngleMinutes + (deltaMinutes / 30);

      m.Rotation = newPositionMinutes;

      timerIDAnimateMinutes = setTimeout("AnimateMinutes(" + newPositionMinutes + ")", 20);  }

  else

    { m.Rotation       = angleMinutes;

      animatingMinutes = false;  } } 



/////////////////////////////////////////////////////////////////////////////////////////



function AnimateHours(currentAngleHours)

    {

      animatingHours = true;



  if (currentAngleHours > (angleHours + 1))

    { var deltaHours = currentAngleHours - angleHours;

      var newPositionHours = currentAngleHours - (deltaHours / 40);



      h.Rotation = newPositionHours;

      timerIDAnimateHours = setTimeout("AnimateHours(" + newPositionHours + ")", 20);  }

  else

    { h.Rotation = angleHours;

      animatingHours = false;  }  }



/////////////////////////////////////////////////////////////////////////////////////////



function AnimateDate(aDate, aTop)

    {

      animatingDate = true;



  if (aDate > uDate)

    { aDate = uDate;   }



      var lNewTop = aTop;

      var lNewDate = aDate;

      var lDeltaDate = uDate - aDate;



      dateDisplay.style.top = aTop + "px";

      setGUIDate(aDate);



  if (aDate < uDate)

    {

    

  if (lDeltaDate > 5) 

    { lDelay  = 30;

      lNewTop += 3;   }

    else

    { lDelay = 50 - (uDate - aDate) * 10;

      lNewTop++;    }

    

  if (lNewTop == 0)

    { lDelay *= 7;  }



  if (lNewTop > 10)

    { lNewTop = -10;

      lNewDate++;  }

      timerIDAnimateDate = setTimeout("AnimateDate(" + lNewDate + "," + lNewTop + ")", lDelay);  }

  else

    {  

  if (aTop < 0) 

    { lNewTop++;    

      timerIDAnimateDate = setTimeout("AnimateDate(" + aDate + "," + lNewTop + ")", 70);    }

    else 

    { animatingDate = false;    }  }  } 



/////////////////////////////////////////////////////////////////////////////////////////



function AnimateDay(aDay, aTop)

    {

      animatingDay = true;



      var lNewTop = aTop;

      var lNewDay = aDay;

  

  dayDisplay.style.top = aTop + "px";

  setGUIDay(aDay);



  if (aDay < uDay)

    {     

      lNewTop++;

    

  if (lNewTop > 10)

    { lNewTop = -10;

      lNewDay++;    }

    

  if (lNewTop == 0) 

    { lTimeOut = 400; }

    else {

      lTimeOut = 50;  }

      timerIDAnimateDay = setTimeout("AnimateDay(" + lNewDay + "," + lNewTop + ")", lTimeOut);  }

  else

    {

  if (lNewTop < 0)

    {  lTimeout = 100 + 5 * lNewTop;

       lNewTop++;    

       timerIDAnimateDay = setTimeout("AnimateDay(" + lNewDay + "," + lNewTop + ")", lTimeout); }

   else 

    { animatingDay = false; }  }  } 



/////////////////////////////////////////////////////////////////////////////////////////



function AnimateDigitalTime(aHours, aMinutes, aSeconds)

    {

      updateDigitalTime(hours, minutes, seconds);

      animatingDigitalTime = false;    } 

